IMPLEMENTATION MODULE BackTrack;

(*
TYPE WertTyp  = INTEGER;
     BOOLFUNC = PROCEDURE () : BOOLEAN;
     INTFUNC  = PROCEDURE () : WertTyp;
     INTPROC  = PROCEDURE (WertTyp);
*)

PROCEDURE MinMax(Tiefe : CARDINAL;
                 ComputerAmZug, NaechsterZug : BOOLFUNC;
                 ZugZurueck : PROC; MarkiereZug : INTPROC;
                 StellungsWert : INTFUNC) : WertTyp;

  PROCEDURE AlphaBeta (Tiefe : CARDINAL; Alpha, Beta : WertTyp) : WertTyp;
    VAR M, N : WertTyp;
        Termin : BOOLEAN;
    BEGIN
      Termin:=TRUE;
      IF Tiefe<>0
      THEN
        IF ComputerAmZug()
        THEN
          M:=Alpha;
          WHILE (M<Beta) AND NaechsterZug() DO
            Termin:=FALSE;
            N:=AlphaBeta(Tiefe-1, M, Beta);
            ZugZurueck;
            IF N>M
            THEN
              M:=N;
              MarkiereZug(M)
            END
          END
        ELSE
          M:=Beta;
          WHILE (M>Alpha) AND NaechsterZug() DO
            Termin:=FALSE;
            N:=AlphaBeta(Tiefe-1, Alpha, M);
            ZugZurueck;
            IF N<M
            THEN
              M:=N;
              MarkiereZug(M)
            END
          END
        END
      END;
      IF Termin
      THEN
        RETURN StellungsWert()
      ELSE
        RETURN M
      END
    END AlphaBeta;

  BEGIN
    RETURN (AlphaBeta(Tiefe, MIN(WertTyp), MAX(WertTyp)))
  END MinMax;

END BackTrack.