MODULE BTEST;

FROM BTREES IMPORT OpenTree, NewTree, CloseTree, BTree, InsertKey,
                   FirstKey, NextKey, Height;
FROM RAND IMPORT Random;
FROM InOut IMPORT WriteCard, WriteString, WriteLn;
FROM SYSTEM IMPORT ADDRESS;

TYPE STRING = ARRAY[0..255] OF CHAR;

PROCEDURE RandomString(VAR S : STRING; l : CARDINAL);
  BEGIN
    S[l]:=0C;
    WHILE l>0 DO
      DEC(l);
      S[l]:=CHR(65+TRUNC(26.0*Random()))
    END
  END RandomString;

VAR  Strings : BTree;
     i : CARDINAL;
     S : STRING;
     IO : INTEGER;
     okay : BOOLEAN;

PROCEDURE kleiner(X, Y : ADDRESS):BOOLEAN;
  (* Diese Variante funktioniert nur, wenn beide Strings durch 0C
     abgeschlossen sind *)
  VAR i : CARDINAL; SX, SY : POINTER TO STRING;
  BEGIN
    SX:=X; SY:=Y; i:=0;
    LOOP
      IF SX^[i]<SY^[i] THEN RETURN TRUE
      ELSIF (SX^[i]>SY^[i]) OR (SX^[i]=0C) THEN RETURN FALSE
      ELSE INC(i)
      END;
    END
  END kleiner;

BEGIN
  WriteString("Datei erzeugen ");
  NewTree(Strings,"STRINGS",4096,41,kleiner,IO);
  WITH Strings DO
    WriteString("Seite: "); WriteCard(PageSize,1); WriteLn;
    WriteString("Schlssel: "); WriteCard(KeySize,1); WriteLn;
    WriteString("Item: "); WriteCard(ItemSize,1); WriteLn;
    WriteString("n: "); WriteCard(n,1); WriteLn;
  END;
  FOR i:=1 TO 1000 DO
    RandomString(S,40); InsertKey(Strings,S,okay);
    WriteCard(i,3); WriteString(") "); WriteString(S);
    IF NOT okay THEN WriteString(" nicht ") ELSE WriteString(" ") END;
    WriteString("okay."); WriteLn
  END;
  i:=0; WriteLn; WriteString("Baum erstellt"); WriteLn;
  WriteString("Hhe: "); WriteCard(Height(Strings),1); WriteLn;
  FirstKey(Strings,S,okay);
  WHILE okay DO
    INC(i); WriteCard(i,4); WriteString(": ");
    WriteString(S); WriteLn;
    NextKey(Strings,S,okay)
  END;
  CloseTree(Strings,IO);
END BTEST.
