MODULE Count; (* Zhlt die Wortvorkommen in einem Text *)

FROM TEXTFILES IMPORT TextFile, ResetTextFile, CloseTextFile, Done, Read;
FROM InOut IMPORT ReadString, WriteLn, WriteString, WriteCard;
FROM DynStr IMPORT DynString, MakeDynString, ForgetDynString,
                   CompareDynString, WriteDynString;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;

TYPE ListType = POINTER TO Cell;
     Cell = RECORD
              Word : DynString;
              Count : CARDINAL;
              left, right : ListType
            END;

PROCEDURE InsertWord(VAR L : ListType; VAR InsWord : ARRAY OF CHAR);
  VAR tString : DynString;

  PROCEDURE Ins(VAR L : ListType);
    BEGIN
      IF L=NIL THEN
        ALLOCATE(L,SIZE(L^));
        WITH L^ DO Word:=tString; Count:=1; left:=NIL; right:=NIL END
      ELSE
        CASE CompareDynString(tString,L^.Word) OF
          -1 : Ins(L^.left)
        | +1 : Ins(L^.right)
        |  0 : (* Wort ist schon da *)
               INC(L^.Count); ForgetDynString(tString)
        END (* CASE *)
      END (* IF *)
    END Ins;

  BEGIN (* InsertWord *)
    MakeDynString(InsWord,tString);
    Ins(L)
  END InsertWord;

PROCEDURE WriteList(L : ListType);
  BEGIN
    IF L<>NIL THEN
      WriteList(L^.left);
      WriteCard(L^.Count,5); WriteString(" x ");
      WriteDynString(L^.Word); WriteLn;
      WriteList(L^.right)
    END
  END WriteList;

PROCEDURE ReadTextFile(VAR f : TextFile; VAR L : ListType);
  CONST MaxLength = 80;
  VAR State : (Skip, Scan);
      C : CHAR;
      Buffer : ARRAY[0..MaxLength] OF CHAR;
      BufferPtr : CARDINAL;
  BEGIN
    L:=NIL; State:=Skip; Read(f,C);
    WHILE Done DO
      CASE State OF
        Skip : CASE CAP(C) OF
               "A".."Z" : BufferPtr:=0;
                          Buffer[BufferPtr]:=C;
                          State:=Scan
               ELSE
               END
      | Scan : CASE CAP(C) OF
               "A".."Z" : IF BufferPtr<MaxLength
                          THEN INC(BufferPtr);
                               Buffer[BufferPtr]:=C
                          END;
               ELSE
                 IF BufferPtr<MaxLength
                 THEN Buffer[BufferPtr+1]:=0C
                 END;
                 InsertWord(L,Buffer);
                 State:=Skip
               END
      END; (* CASE *)
      Read(f,C)
    END; (* WHILE *)
    IF State=Scan THEN
      IF BufferPtr<MaxLength
      THEN Buffer[BufferPtr+1]:=0C
      END;
      InsertWord(L,Buffer)
    END
  END ReadTextFile;

VAR FileName : ARRAY[0..40] OF CHAR;
    Text : TextFile;
    WordList : ListType;
BEGIN
  WriteString("File: "); ReadString(FileName); WriteLn;
  ResetTextFile(Text,FileName);
  IF Done THEN 
    ReadTextFile(Text,WordList);
    CloseTextFile(Text);
    WriteList(WordList)
  ELSE WriteString("Keine Datei!"); WriteLn
  END
END Count.
