MODULE GAMMA; (* fuer TopSpeed *)

FROM IO IMPORT RdLngReal, WrLngReal, WrStr, WrLn, RdLn, OK;
FROM MATHLIB IMPORT Exp, Log;
FROM INTEGRAL IMPORT Integral;

VAR x1 : LONGREAL; (* Gamma(x1+1) soll berechnet werden *)

PROCEDURE f(u : LONGREAL) : LONGREAL;
  BEGIN
    IF (u<=0.0) OR (u>=1.0)
    THEN RETURN 1.0
    ELSE RETURN Exp(Log(-Log(u))*x1)
    END
  END f;

PROCEDURE Gamma(x : LONGREAL) : LONGREAL;
  (* Gamma-funktion auf 14 Stellen   *)
  (* 1<=x<=2 zur besseren Konvergenz *)
  BEGIN
    x1:=x-1.0;
    RETURN Integral(f,0.0,1.0,1.0E-14)
  END Gamma;

VAR a : LONGREAL;
BEGIN
  WrStr('Bitte eine Zahl zwischen 1 und 2 eingeben'); WrLn;
  a:=RdLngReal();
  IF OK THEN
    WrStr('Gamma = ');
    WrLngReal(Gamma(a),14,20); WrLn;
  END;
END GAMMA.
