IMPLEMENTATION MODULE LOWFILES;     (* Fr Modula-Versionen mit
                                       FileSystem wie bei Wirth,
                                       Beispiel Logitech *)

  FROM SYSTEM IMPORT BYTE, ADR;
  FROM Storage IMPORT ALLOCATE, DEALLOCATE;
  IMPORT FileSystem;

  TYPE LowFile = POINTER TO FileSystem.File;

  PROCEDURE ResetLowFile(VAR f : LowFile; fn : ARRAY OF CHAR;
                         VAR IO : INTEGER);
    BEGIN
      ALLOCATE(f,SIZE(f^));
      FileSystem.Lookup(f^,fn,FALSE);
      IO:=1-ORD(f^.res=FileSystem.done);
      IF IO<>0 THEN DEALLOCATE(f,SIZE(f^)); f:=NIL; RETURN END;
      FileSystem.SetModify(f^);
    END ResetLowFile;

  PROCEDURE RewriteLowFile(VAR f : LowFile; fn : ARRAY OF CHAR;
                           VAR IO : INTEGER);
    BEGIN
      ALLOCATE(f,SIZE(f^));
      FileSystem.Delete(fn,f^);
      FileSystem.Lookup(f^,fn,TRUE);
      IO:=1-ORD(f^.res=FileSystem.done);
      IF IO<>0 THEN DEALLOCATE(f,SIZE(f^)); f:=NIL; RETURN END;
      FileSystem.SetModify(f^);
    END RewriteLowFile;

  PROCEDURE CloseLowFile(VAR f : LowFile; VAR IO : INTEGER);
    BEGIN
      IF f=NIL THEN IO:=1; RETURN; END;
      FileSystem.Close(f^);
      IO:=1-ORD(f^.res=FileSystem.done);
      DEALLOCATE(f,SIZE(f^)); f:=NIL
    END CloseLowFile;

  PROCEDURE LowFileSize(VAR f : LowFile; VAR IO : INTEGER) : FilePos;
    VAR sl, sh : CARDINAL;
        v : REAL;
    BEGIN
      IF f=NIL
      THEN IO:=1; v:=0.0;
      ELSE FileSystem.Length(f^, sh, sl);
           IO:=1-ORD(f^.res=FileSystem.done);
           v:=FLOAT(sh) * 65536.0 + FLOAT(sl);
      END;
      RETURN v
    END LowFileSize;

  PROCEDURE WriteNBytes(VAR f : LowFile; pos : FilePos;
                        anz : CARDINAL; VAR buffer : ARRAY OF BYTE;
                        VAR IO : INTEGER);
    VAR n, l, h : CARDINAL;
    BEGIN
      IF f=NIL THEN IO:=1; RETURN; END;
      h:=TRUNC(pos/65536.0);
      l:=TRUNC(pos-65536.0*FLOAT(h));
      FileSystem.SetPos(f^,h,l);
      IO:=1-ORD(f^.res=FileSystem.done);
      IF IO=0 THEN
        FileSystem.WriteNBytes(f^,ADR(buffer),anz,n);
        IO:=1-ORD((f^.res=FileSystem.done) AND (anz=n));
      END (* IF *)
    END WriteNBytes;

  PROCEDURE ReadNBytes(VAR f : LowFile; pos : FilePos;
                       anz : CARDINAL; VAR buffer : ARRAY OF BYTE;
                       VAR IO : INTEGER);
    VAR n, l, h : CARDINAL;
    BEGIN
      IF f=NIL THEN IO:=1; RETURN; END;
      h:=TRUNC(pos/65536.0);
      l:=TRUNC(pos-65536.0*FLOAT(h));
      FileSystem.SetPos(f^,h,l);
      IO:=1-ORD(f^.res=FileSystem.done);
      IF IO=0 THEN
        FileSystem.ReadNBytes(f^,ADR(buffer),anz,n);
        IO:=1-ORD((f^.res=FileSystem.done) AND (n=anz))
      END (* IF *)
    END ReadNBytes;

END LOWFILES.
