IMPLEMENTATION MODULE SORT;

FROM Storage IMPORT Available, DEALLOCATE, ALLOCATE;
FROM SYSTEM IMPORT ADDRESS;

TYPE Liste = POINTER TO Kopf;
     Kopf  = RECORD
               Inhalt : ADDRESS;
               Rest   : Liste
             END;
     SList = RECORD
               Anfang, Ende : Liste
             END;

VAR SortList : SList;

PROCEDURE Move(From, To : ADDRESS; Size : CARDINAL);
  (* Kann durch eine eventuell vorhandene Bibliotheksprozedur
     ersetzt werden. Hat jedoch keinen Einflu auf die Sortier-
     zeit, sondern beeintrchtigt nur den Datentransfer *)
  VAR p1,p2 : POINTER TO ARRAY[0..MAX(INTEGER)] OF BYTE;
  VAR i : CARDINAL;
  BEGIN
    p1:=From; p2:=To;
    FOR i:=0 TO Size-1 DO p2^[i]:=p1^[i] END;
  END Move;

PROCEDURE append(L1,L2 : SList; VAR L : SList);
  (* L:=L2 angehngt an L1 *)
  BEGIN
    IF L1.Anfang=NIL THEN L:=L2    (* Wenn erste Liste leer, ist L:=L2   *)
    ELSIF L2.Anfang=NIL THEN L:=L1 (* Wenn zweite Liste leer, ist L:=L1  *)
    ELSE                           (* Ansonsten zusammenhngen           *)
      L.Anfang:=L1.Anfang;
      L1.Ende^.Rest:=L2.Anfang;
      L.Ende:=L2.Ende;
    END (* IF *)
  END append;

PROCEDURE CallSort(less : Relation);

  PROCEDURE SORT(VAR L : SList); (* Rekursiver Quicksort fr Listen *)

  VAR L1,L2 : SList;
      t,v : Liste;
      Mitte : Liste;
      (* gefunden, weiter : BOOLEAN; *)

  PROCEDURE Zerlege(VAR L,L1,L2: SList; VAR Mitte : Liste);
    VAR p,p0,q,q0 : Liste; s,g : BOOLEAN;

    PROCEDURE revers(VAR L : SList);   (* Liste L wird umgedreht *)
      VAR p,q,a,e,t : Liste;
      BEGIN
        a:=L.Anfang; e:=L.Ende; q:=a; p:=q^.Rest;
        WHILE p<>NIL DO t:=p^.Rest; p^.Rest:=q; q:=p; p:=t END;
        a^.Rest:=NIL; L.Anfang:=e; L.Ende:=a;
      END revers;

    BEGIN (* Zerlege *)
      q:=L.Anfang; p:=q^.Rest; p0:=q; s:=FALSE;
      IF less(q^.Inhalt,p^.Inhalt)
      THEN  (* aufsteigend *)
        WHILE (p<>NIL) AND less(p0^.Inhalt,p^.Inhalt) DO
          p0:=p; p:=p^.Rest; s:=NOT s;
          IF s THEN q0:=q; q:=q^.Rest END;
        END; (* WHILE *)
        IF p=NIL THEN Mitte:=NIL; RETURN
        ELSE
          L1.Anfang:=L.Anfang; L1.Ende:=q0; Mitte:=q; L.Anfang:=p;
          IF p0=q
          THEN L2.Anfang:=NIL; L2.Ende:=NIL
          ELSE L2.Anfang:=q^.Rest; L2.Ende:=p0; L2.Ende^.Rest:=NIL;
          END;
          L1.Ende^.Rest:=NIL
        END
      ELSE (* absteigend *)
        WHILE (p<>NIL) AND NOT less(p0^.Inhalt,p^.Inhalt) DO
          p0:=p; p:=p^.Rest; s:=NOT s;
          IF s THEN q0:=q; q:=q^.Rest END;
        END; (* WHILE *)
        IF p=NIL THEN revers(L); Mitte:=NIL; RETURN
        ELSE
          L2.Anfang:=L.Anfang; L2.Ende:=q0; Mitte:=q; L.Anfang:=p;
          IF p0=q
          THEN
            Mitte:=q0; L1.Anfang:=q; L1.Ende:=q;
            L2.Anfang:=NIL; L2.Ende:=NIL;
          ELSE L1.Anfang:=q^.Rest; L1.Ende:=p0; L1.Ende^.Rest:=NIL;
          END;
          IF L2.Anfang<>NIL
          THEN L2.Ende^.Rest:=NIL
          ELSE L1.Ende^.Rest:=NIL
          END
        END
      END (* IF *)
    END Zerlege;

  BEGIN (* SORT *)
    IF (L.Anfang<>NIL) AND (L.Anfang^.Rest<>NIL)
    (* Es mu mehr als ein Element sein *)
    THEN
      Zerlege(L,L1,L2,Mitte);
      IF Mitte<>NIL                   (* Nur wenn Liste noch nicht sortiert *)
      THEN
        t:=L.Anfang;
        WHILE t<>NIL DO
          v:=t; t:=t^.Rest;
          IF less(v^.Inhalt,Mitte^.Inhalt)
          THEN v^.Rest:=L1.Anfang; L1.Anfang:=v
          ELSE v^.Rest:=L2.Anfang; L2.Anfang:=v;
               IF L2.Ende=NIL THEN L2.Ende:=v END
          END; (* IF *)
        END; (* WHILE *)
        Mitte^.Rest:=L2.Anfang;
        IF L2.Anfang=NIL THEN L2.Ende:=Mitte END;
        L2.Anfang:=Mitte;
        L1.Ende^.Rest:=NIL;
        L2.Ende^.Rest:=NIL;
        SORT(L1); SORT(L2);           (* Bevor die Teillisten zusammengefgt*)
        append(L1,L2,L);              (* werden, mssen sie selbst sortiert *)
      END (* IF *)                    (* werden.                            *)
    END (* IF *)
    END SORT;

  BEGIN
    SORT(SortList)
  END CallSort;

PROCEDURE InitSort;
  VAR p : Liste;
  BEGIN
    WHILE SortList.Anfang<>NIL DO
      p:=SortList.Anfang;
      SortList.Anfang:=SortList.Anfang^.Rest;
      DEALLOCATE(p,SIZE(p^));
    END;
    SortError:=FALSE
  END InitSort;

PROCEDURE ToSort(V : ARRAY OF BYTE);
  VAR p : Liste;
  BEGIN
    IF Available(SIZE(p^))
    THEN ALLOCATE(p,SIZE(p^))
    ELSE SortError:=TRUE; RETURN
    END;
    IF Available(HIGH(V)+1)
    THEN ALLOCATE(p^.Inhalt,1+HIGH(V))
    ELSE SortError:=TRUE; RETURN
    END;
    Move(ADR(V),p^.Inhalt,1+HIGH(V));
    p^.Rest:=NIL;
    WITH SortList DO
      IF Anfang=NIL
      THEN Anfang:=p; Ende:=p
      ELSE Ende^.Rest:=p; Ende:=p
      END
    END (* WITH *)
  END ToSort;

PROCEDURE FromSort(VAR V : ARRAY OF BYTE);
  BEGIN
    IF SortList.Anfang<>NIL
    THEN
      Move(SortList.Anfang^.Inhalt,ADR(V),1+HIGH(V));
      SortList.Anfang:=SortList.Anfang^.Rest;
    ELSE SortError:=TRUE
    END
  END FromSort;

PROCEDURE SortEmpty():BOOLEAN;
  BEGIN
    RETURN SortList.Anfang=NIL
  END SortEmpty;

BEGIN
  SortList.Anfang:=NIL;
END SORT.